/***************************************************************************
                          qdvbzap.cpp  -  description
                             -------------------
    begin                : Mon Jun 30 01:19:24 CEST 2003
    copyright            : (C) 2003 by Andre Stein
    email                : stone@steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qhbox.h>
#include <qvbox.h>
#include <qtoolbutton.h>
#include "qdvbzap.h"
#include "qdvbzapapplicationchooser.h"

//xpms
#include "icons/xine.xpm"
#include "icons/stop.xpm"

//define/const
const int INITAL_X = 200;
const int INITAL_Y = 220;

/***************************************************************************
   constructor/destructor
 ***************************************************************************/   

QdvbzapWindow::QdvbzapWindow()
: QMainWindow(0, 0, Qt::WStyle_Customize | Qt::WStyle_Tool)
{
	setCaption("steinSOFT qdvbzap " VERSION);

       	/************************
	 * setup of main window *
	 ************************/

	 createLayout();
	 
	//set inital size
	resize(INITAL_X, INITAL_Y);

	//set statusbar font	
	QFont font = statusBar()->font();
	font.setPointSize(font.pointSize()-1);
	font.setBold(true);
	statusBar()->setFont(font);
	//set inital statusbar messsage and setuo
	statusBar()->message("ready for zapping.");
}


QdvbzapWindow::~QdvbzapWindow()
{
}

/***************************************************************************
   functions
 ***************************************************************************/

 /** creates layout of mainwindow */
void QdvbzapWindow::createLayout()
{
	QVBox* verticalBox = new QVBox(this);

	//create main listbox containig channels
	channelList = new QdvbzapChannelList(verticalBox);
	QHBox* buttons = new QHBox(verticalBox);

        /** buttons */
        //WATCH NOW!
       	QToolButton* watchNow = new QToolButton(buttons);
	watchNow->setPixmap(QPixmap(xine_xpm));
	watchNow->setMaximumWidth(30);
	QObject::connect(watchNow, SIGNAL(clicked()),
		         channelList, SLOT(slotWatchCurrentChannel()));
	//STOP WATCHING
	QToolButton* stopNow = new QToolButton(buttons);
	stopNow->setPixmap(QPixmap(stop_xpm));
	stopNow->setMaximumWidth(30);
	QObject::connect(stopNow, SIGNAL(clicked()),
			 channelList, SLOT(slotStopWatching()));
	//APPLICATION BAR
        QdvbzapApplicationChooser* applicationChooser = new
		QdvbzapApplicationChooser(buttons, channelList->getChannelViewer());

	
	//main item on scene
	setCentralWidget(verticalBox);
}

/** overwritten function */
void QdvbzapWindow::destroy(bool destroyWindow, bool destroySubWindows)
{
	channelList->save();

	//parent, do da job
	QMainWindow::destroy(destroyWindow, destroySubWindows);
}
 
/***************************************************************************
   slots
 ***************************************************************************/
 

