/***************************************************************************
                          qdvbzapapplicationchooser.cpp  -  description
                             -------------------
    begin                : Sat Jul 12 2003
    copyright            : (C) 2003 by Andre Stein
    email                : stone@steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "qdvbzapapplicationchooser.h"

/***************************************************************************
   constructor/destructor
 ***************************************************************************/  

QdvbzapApplicationChooser::QdvbzapApplicationChooser(QWidget *parent, SChannelViewer* channelViewer )
: QPushButton(parent)
{
	this->channelViewer = channelViewer;

	//create popup menu and associate to button
	popupMenu = new QPopupMenu(this);
	QObject::connect(popupMenu, SIGNAL(activated(int)),
			 this, SLOT(slotPopupmenuActivated(int)));
	setPopup(popupMenu);

	//first update
	updatePopupMenu();
	//get text from item
	setText(popupMenu->text(0));
}

QdvbzapApplicationChooser::~QdvbzapApplicationChooser()
{
}

/***************************************************************************
   functions
 ***************************************************************************/

/** recreates popupmenu shown on click */
void QdvbzapApplicationChooser::updatePopupMenu()
{
	int i = 0;
	SFrontendApp* current;
	//reset to inital state first
	popupMenu->clear();
	
        while ( (current = channelViewer->iterateNextApplication()) )
        {
		//have to set id manually as it seems to be always 0
		popupMenu->insertItem(current->name, 0, 0, 0, i);
		++i;
        }
}
/** No descriptions */
void QdvbzapApplicationChooser::slotPopupmenuActivated(int id)
{
	//set button's text depending on selected item
	setText(popupMenu->text(id));

	//update channelviewer to use reuqested frontend app
	channelViewer->setActiveApplication(popupMenu->text(id));
}
