/***************************************************************************
                          qdvbzapapplicationchooser.h  -  description
                             -------------------
    begin                : Sat Jul 12 2003
    copyright            : (C) 2003 by Andre Stein
    email                : stone@steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QDVBZAPAPPLICATIONCHOOSER_H
#define QDVBZAPAPPLICATIONCHOOSER_H

#include <qpushbutton.h>
#include <qpopupmenu.h>
#include "schannelviewer.h"

/** This class represents a toolbutton that manages what
  * application is used to watch TV. Implements a
  * auto-generated popup menu.
  *@author Andre Stein
  */

class QdvbzapApplicationChooser : public QPushButton
{
   Q_OBJECT
public: 
	QdvbzapApplicationChooser(QWidget *parent, SChannelViewer* channelViewer);
	~QdvbzapApplicationChooser();
protected: // Protected methods
	/** recreates popupmenu shown on click */
	void updatePopupMenu();

	/** pointer to channelviewer instance */
	SChannelViewer* channelViewer;
	QPopupMenu* popupMenu;
public slots: // Public slots
	/** No descriptions */
	void slotPopupmenuActivated(int id);
};

#endif
