/***************************************************************************
                          qdvbzapchannellist.h  -  description
                             -------------------
    begin                : Mon Jun 30 2003
    copyright            : (C) 2003 by Andre Stein
    email                : stone@steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QDVBZAPCHANNELLIST_H
#define QDVBZAPCHANNELLIST_H

#include <qlistbox.h>
#include <qpopupmenu.h>
#include "schannellist.h"
#include "qdvbzapchanneltooltip.h"
#include "schannelviewer.h"

/** This class represents the Qt part of the channel list,
  * the graphical part. It displays the channels provided by
  * SChannelList and takes action when clicked.
  * @author Andre Stein
  */

class QdvbzapChannelList : public QListBox
{
Q_OBJECT
public: 
	QdvbzapChannelList(QWidget *parent = 0, const char *name = 0);
	virtual ~QdvbzapChannelList();

	SChannelList& getChannelList() { return channelList; }
	SChannelViewer* getChannelViewer() { return &channelViewer; }
	/** overwritten function to display a popup menu */
	void contextMenuEvent ( QContextMenuEvent * e );
	/** saves everything */
	void save();
protected:
	QPopupMenu* popupMenu;
	SChannelList channelList;
	SChannelViewer channelViewer;
protected: // Protected methods
	/** recreates list of channels */
	void reCreateList();
public slots: // Public slots
	/** slot for signak doubleClicked() */
	void slotDoubleClicked(QListBoxItem* item);
	/** view currently selected channel using currently selected frontend app */
	void slotWatchCurrentChannel();
	/** slot functions that imports channels from an exisiting file */
	void slotImportChannels();
	/** No descriptions */
	void slotClearList();
	/** No descriptions */
	void slotDeleteCurrent();
  /** stops currently active frontend app */
  void slotStopWatching();
};

#endif
