/***************************************************************************
                          qdvbzapchanneltooltip.cpp  -  description
                             -------------------
    begin                : Fri Jul 11 2003
    copyright            : (C) 2003 by Andre Stein
    email                : stone@steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "qdvbzapchanneltooltip.h"

/***************************************************************************
   constructor/destructor
 ***************************************************************************/  

QdvbzapChannelTooltip::QdvbzapChannelTooltip(QWidget *parent)
: QToolTip(parent)
{
}

QdvbzapChannelTooltip::~QdvbzapChannelTooltip()
{
}

/***************************************************************************
   functions
 ***************************************************************************/

/** overwritten maybeTip implementation to show the right tip */
void QdvbzapChannelTooltip::maybeTip(const QPoint& point)
{
	QString tooltipText;
	//save parent in pointer
	QdvbzapChannelList* parent = (QdvbzapChannelList*)parentWidget();

	//get information of item
	QListBoxItem* item = parent->itemAt(point);

	//if no item found at that position, exit
	if (!item)
	{
		return;
	}

	//get information about that channel
	SChannel* channel = parent->getChannelList().lookup(item->text());

	//construct tooltip text using information from
	//channel/channellist
	tooltipText = QString("<b>") + channel->name + "</b><br>"
		"&nbsp;&nbsp;Frequency: <b>" + QString("%1").arg(channel->frequency) + "</b><br>"
		"&nbsp;&nbsp;Polarisation: <b>" +  (channel->polarisation == POL_H ? "H" : "V") + "</b><br>"
		"&nbsp;&nbsp;Symbolrate: <b>" + QString("%1").arg(channel->symbolRate) + "</b><br>"
		"&nbsp;&nbsp;V-Pid: <b>" + QString("%1").arg(channel->pids[0]) + "</b><br>"
		"&nbsp;&nbsp;A-Pid: <b>" + QString("%1").arg(channel->pids[1]) + "</b>";

	//finally show tip
	tip(parent->itemRect(item), tooltipText);	
}
