/***************************************************************************
                          schannelviewer.h  -  description
                             -------------------
    begin                : Mon Jun 30 2003
    copyright            : (C) 2003 by Andre Stein
    email                : stone@steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCHANNELVIEWER_H
#define SCHANNELVIEWER_H

#include <qstring.h>
#include "schannellist.h"

struct SFrontendApp
{
	QString name;
	QString command;
	QString processName;
};

/** This class manages viewing the desired channel. It takes
  * cares that all necessary apps are installed and cleans
  * old processes up.
  * @author Andre Stein
  */
class SChannelViewer
{
public: 
	SChannelViewer();
	~SChannelViewer();
	/** start watching selected channel */
	void watchChannel(SChannel* channel);
	/** sets active frontend application */
	void setActiveApplication(const QString& appName);
	/** adds a new frontend application */
	void addApplication(QString name, QString command, QString processName);
	/** gets next application in list, 0 for end */
	SFrontendApp* iterateNextApplication();
	/** terminate currently running frontend app */
	void stopWatching();
protected:
	vector<SFrontendApp> apps;
	bool isRunning;
	int activeApp;
};

#endif
